/***************************************************************************
                          main.c  -  description
                             -------------------
    begin                : Fre Nov 10 16:22:38 CET 2000
    copyright            : (C) 2000 by Markus Fruehwirth
    email                : 7ox@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "SJBsheet.h"


/* name: doit
 * var: none
 * exitcode:0 (for normal termination - returncode)
 * explanation: generates a sheet from a mapping file
*/
int
doit ()
{
  int back;
  FILE *read, *write;		//filename
  char *line, *saveline;	//line
  int max[MAXFIELD][MAXFIELD];
  int col, *colp, maxcol;		//columns
  int row, *rowp, maxrow;
  int i, j, k;
  int stop, maximum, sum;

back=-1;

line = malloc (MAXLENLINE * sizeof (char));
saveline = malloc (MAXLENLINE * sizeof (char));
colp = &col;
rowp = &row;

sum=0;
col=0;
row=0;
maxrow=0;
maxcol=0;
maximum=0;
for (i=0;i<MAXFIELD;i++)
    for (j=0;j<MAXFIELD;j++)
        max[i][j]=0;

//open mappingfile
//read = fopen ("/home/markus/Diplomarbeit/dev/nn.mapping", "r");
read=stdin;
  if (read == NULL)		//no file opened
    exit (ERROR);

write = stdout;

//cut preambel
for (i=0;i<PREAMBEL;i++)
    saveline = fgets (line, MAXLENLINE, read);


//start reading file
stop=FALSE;
saveline = fgets (line, MAXLENLINE, read);
	 if (saveline == NULL)
	    stop = TRUE;
while (stop==FALSE)
{
back = sscanf (line, "%d %d", colp, rowp);
//col und row sind vertauscht, wegen falscher Syntax in ghSOM & SOMlib
if (maxrow < row)
    maxrow=row;
if (maxcol < col)
    maxcol=col;

max[col][row]=max[col][row]+1;

fprintf(write, "%s", line);
saveline = fgets (line, MAXLENLINE, read);
	 if (saveline == NULL)
	    stop = TRUE;
}

//file now finished
read=NULL;
(void) fflush(write);


//now fill output with zerovalues
//do that for each row:
//i=0;
for (i=0;i<=maxrow;i++) //rows
    { //calulate maximum
    maximum=0;
    for (j=0;j<=maxcol;j++) //look in each column if higher
        if (max[j][i]>maximum)
            maximum = max[j][i];
    //now maximum of current row in maximum
    for (j=0;j<=maxcol;j++)
        {//print out zero values
        sum=maximum-max[j][i];
        for (k=0;k<sum;k++)
            fprintf(write,"%d %d zzzzzzzzzz 0.0\n",j,i);
        }
     }

//all done
(void) fflush(write);
write=NULL;
free(saveline);
free(line);

  if (back > 0)
    back = 0;

  return back;
}


/* name: main
 * var: none
 * exitcode:0 (for normal termination - returncode)
 * explanation: calls doit
*/
int
main (int argc, char *argv[])
{
  int back = -1;

  if (argc == 1)
    back = doit ();
  else
    {
      (void) fprintf (stderr, "%s: wrong Usage: %s\n", argv[0], argv[0]);
      exit (EXIT_FAILURE);
    }
  return back;
}
